function splitArray(bigarray, size){
	var splicedArray = [];
	for (var i=0; i<bigarray.length; i+=size) {
		var smallarray = bigarray.slice(i,i+size);
		splicedArray.push(smallarray);
	}
	return splicedArray;
}

function combineChunks(arrayOfArrays){
	var arr = [];
	for(var i =0; i < arrayOfArrays.length; i++){
		for(var j =0; j < arrayOfArrays[i].length; j++){
			arr.push(arrayOfArrays[i][j]);
		}	
	}
	return arr;
}

function isNullOrUndefined (value){
	return (value === null || value === undefined);
}

function RotateLeft(arr)
{
	var topRow = arr.shift();
	arr.push(topRow);
	return arr;
}		

function RotateRight(arr)
{
	arr.reverse();
	RotateLeft(arr);
	arr.reverse();
	return arr;
}	

function bit_test(num,bit){
    return ((num>>bit) % 2 != 0)
}

function bit_set_bool(num,bit,bool){
    return num | 1<<bit;
}

function bit_set(num,bit){
    return num | 1<<bit;
}

function bit_clear(num,bit){
    return num & ~(1<<bit);
}

function bit_toggle(num,bit){
    return bit_test(num,bit)?bit_clear(num,bit):bit_set(num,bit);
}

function bitShiftLeft(val,width)
{
	var mask = 0x01 << (width-1);
	var shiftRegister = (val & mask) >>> width-1;
	//alert(shiftRegister);
	return (val << 1) | shiftRegister;
}

function bitShiftRight(val,width)
{
	var mask = 0x01 ;
	var shiftRegister = (val & mask) << width-1;
	//alert(shiftRegister);
	return (val >> 1) | shiftRegister;
}

function bitReverse8(val)
{
	return  ( 
			((val & 128) >> 7 ) | 
			((val & 64) >> 5  ) | 
			((val & 32) >> 3  ) | 
			((val & 16) >> 1  ) | 
			((val & 8) << 1   ) | 
			((val & 4) << 3   ) | 
			((val & 2) << 5   ) | 
			((val & 1) << 7   )         
			);
}